---
name: Bug report
about: Report a run-time problem
title: ''
labels: ''
assignees: ''

---

IMPORTANT NOTE
--------------

This is a _template_, please **REMOVE** all the placeholders after filling in all the applicable sections as indicated, including this note.

Please also note that this entry field uses [Markdown][1], which means that you need to escape any code snippets pasted here using the fenced code blocks, i.e. by putting <tt>```</tt> before and after it. Also escape, using backslash, i.e. `\<` any angle brackets to prevent them from being interpreted as HTML tags.

[1]: https://docs.github.com/github/writing-on-github/getting-started-with-writing-and-formatting-on-github/basic-writing-and-formatting-syntax

---

**Describe the bug**
A clear and concise description of what the bug is.

**Expected vs observed behaviour**
Please describe what you expected to happen and what actually happens. Make sure to explain what exactly is the problem, just attaching a screenshot is not always sufficient. When in doubt, please provide more details rather than too few.

**Patch or snippet allowing to reproduce the problem**
Please attach the smallest possible patch allowing to reproduce the problem in a sample. If there is absolutely no appropriate sample, please attach a minimal self-contained example in a single file.

Skip this step if the problem can be reproduced in one of the samples without any changes.

**To Reproduce**
Steps to reproduce the behaviour, please make them as detailed as possible, e.g.
1. Go to '...'
2. Click on '....'
3. Scroll down to '....'
4. See error

**Platform and version information**
 - wxWidgets version you use: [e.g. 3.1.6]
 - wxWidgets port you use: [e.g. wxMSW, wxGTK, wxOSX]
 - OS and its version: [e.g. Windows 10.0.19042.867, Ubuntu 22.10, macOS 15]
 - For wxGTK only (**remove** this if not using wxGTK)
   + GTK version: [e.g. 3.24.5]
   + Which GDK backend is used: [X11 or Wayland]
   + If relevant, i.e. for appearance-related problems: [current theme]
