/////////////////////////////////////////////////////////////////////////////
// Name:        main.h
// Purpose:     Main page of the Doxygen manual
// Author:      wxWidgets team
// Licence:     wxWindows licence
/////////////////////////////////////////////////////////////////////////////

/**

@mainpage Documentation

@image html main_wxlogo.png

@author Julian Smart, Vadim Zeitlin, Robin Dunn, Stefan Csomor,
        Bryan Petty, Francesco Montorsi, Robert Roebling et al

@date September 09, 2024

Welcome to wxWidgets, a stable and powerful open source framework for
developing native cross-platform GUI applications in C++!

If you are new to wxWidgets, please start with the @ref page_introduction
and follow with the @ref page_topics, with maybe a look at @ref page_samples as
you go. Installation instructions for various platforms are available from the
@ref page_port page.

If you are already familiar with wxWidgets and are upgrading from an older
release, please read about @ref overview_changes_since28 "the changes" in the
latest version compared to 2.8 series. And you can also follow the links in the
reference section or jump directly to the
<a href="classes.html">alphabetical list of classes</a> to find out more about
the topic you are interested in.

@section manual_user User Manual

@li @subpage page_introduction
@li @subpage page_topics
@li @subpage page_libs
@li @subpage page_class_cat
@li @subpage overview_changes_since28

@section manual_reference Reference

@li @subpage group_class
@li @subpage group_funcmacro
@li @subpage page_constants

@section manual_misc Other Information

@li @subpage page_samples
@li @subpage page_utils
@li @subpage page_translations
@li @subpage page_multiplatform
@li @subpage page_copyright

*/
