/////////////////////////////////////////////////////////////////////////////
// Name:        wx/osx/minifram.h
// Purpose:     wxMiniFrame class. A small frame for e.g. floating toolbars.
//              If there is no equivalent on your platform, just make it a
//              normal frame.
// Author:      Stefan Csomor
// Modified by:
// Created:     1998-01-01
// Copyright:   (c) Stefan Csomor
// Licence:     wxWindows licence
/////////////////////////////////////////////////////////////////////////////

#ifndef _WX_MINIFRAM_H_
#define _WX_MINIFRAM_H_

#include "wx/frame.h"

class WXDLLIMPEXP_CORE wxMiniFrame: public wxFrame {

  wxDECLARE_DYNAMIC_CLASS(wxMiniFrame);

public:
  wxMiniFrame() {}
  wxMiniFrame(wxWindow *parent,
           wxWindowID id,
           const wxString& title,
           const wxPoint& pos = wxDefaultPosition,
           const wxSize& size = wxDefaultSize,
           long style = wxCAPTION | wxRESIZE_BORDER | wxTINY_CAPTION,
           const wxString& name = wxASCII_STR(wxFrameNameStr))
  {
      // Use wxFrame constructor in absence of more specific code.
      Create(parent, id, title, pos, size, style | wxFRAME_TOOL_WINDOW | wxFRAME_FLOAT_ON_PARENT , name);
  }

  virtual ~wxMiniFrame() {}
protected:
};

#endif
    // _WX_MINIFRAM_H_
